Subject: [mobile-ip] Last minute revisions to RFC2002bis --> RFC 3220

From: "Charles E. Perkins" <[email-masked]>
Date: Fri, 21 Dec 2001 16:15:22 -0800

Hello folks,

RFC2002bis made it to the RFC Editor's desk and was ready to be
published as RFC 3220.  However, the decision was taken to make
one last minute revision, in order to resolve the problem that
had been raised by Siva and Alper regarding the erroneous use of
0.0.0.0 as a destination address for the Registration Reply in
case the mobile node send a Registration Request with source IP
address indicated as 0.0.0.0.

Since RFC 3220 was not published, it was possible to insert these
changes.  Essentially, the new draft mandates use of the mobile
node's home address whenever that is possible, which is in almost
every case.  The case when it is not possible, is when the mobile
node was asking to get a home address, and the Registration Reply
indicates rejection for some reason.

Along the way, I had been informed about a variety of minor
editorial problems -- even, I must say, a spelling error.
So I fixed those also.

The only outstanding issue has to do with prohibiting retransmitted
Registration Requests from using alternative NAIs.  This "could"
be considered "obvious", and so it was felt that there was no need
to further perturb the contents of RFC 2002bis.

Below, please find a complete list of all changes from RFC2002bis
as it was at the conclusion of IETF Last Call, and what will be
hopefully published very soon by the RFC Editor.  If there is any
objection to these changes, please let me know ASAP.

Happy Holidays!

Regards,
Charlie P.

PS. The "Changes" appendix materials probably will disappear...

================= Last-Minute Changes to RFC2002bis ====================

"<" == new
">" == old

639c639
<     a) A "foreign agent care-of address" is a care-of address provided
---
>     -  A "foreign agent care-of address" is a care-of address provided
649c649
<     b) A "co-located care-of address" is a care-of address acquired
---
>     -  A "co-located care-of address" is a care-of address acquired

712a713,744
>    For example, the figure below illustrates the routing of datagrams
>    to and from a mobile node away from home, once the mobile node has
>    registered with its home agent.  In the figure below, the mobile node
>    is using a foreign agent care-of address:
736,766d767
<    For example, figure 1 illustrates the routing of datagrams to
<    and from a mobile node away from home, once the mobile node has
<    registered with its home agent.  In figure 1, the mobile node is
<    using a foreign agent care-of address, not a co-located care-of
<    address.

774,775c775,776
<    Router Discovery messages.  Some extensions have been specified
<    to be encoded in the simple Type-Length-Value format described in
>    Router Discovery messages.  Some extensions have been specified to be
>    encoded in the following simple Type-Length-Value format described in

872c872
<    extension structure does not encourage the most efficient usage
---
>    extension structures does not encourage the most efficient usage

917c917
<        0                   1                   2                   3
---
>       0                   1                   2                   3

930,931c930,931
<       Type     is the type which describes a collection of extensions
<                which have a common data type.
---
>       Type     is the type which describe a collection of extensions
>                which has a common data type.
982c982
<        0                   1                   2                   3
---
>       0                   1                   2                   3
992,993c992,993
<       Type     is the type which describes a collection of extensions
<                which have a common data type.
---
>       Type     is the type which describe a collection of extensions
>                which has a common data type.

1240,1241c1240,1241
<    'F' bit is not also set.  Furthermore, at least one of the 'F' bit
<    and the 'H' bit MUST be set in any Agent Advertisement message sent.
---
>    'F' bit is not also set, and at least one of the 'F' bit and the 'H'
>    bit MUST be set in any Agent Advertisement message sent.

1343,1346c1343,1344
<    Agent Solicitation.  All mobility agents MUST join the Mobile-Agents
<    multicast group, at address 224.0.0.11.  A mobile node MAY send an
<    Agent Solitication to 224.0.0.11.  All mobility agents SHOULD respond
<    to Agent Solicitations.
---
>    Agent Solicitation.  All mobility agents SHOULD respond to Agent
>    Solicitations.

1417,1419c1417,1419
<    nodes can distinguish a reduction in the sequence number that occurs
<    after a reboot from a reduction that results in rollover of the
<    sequence number after it attains the value 0xffff.
---
>    nodes can distinguish reductions in sequence numbers that result from
>    reboots, from reductions that result in rollover of the sequence
>    number after it attains the value 0xffff.

2372,2373c2372,2373
<     -  Otherwise, if the mobile node does not have a home address, the
<        IP source address MUST be 0.0.0.0.
---
>     -  If the mobile node does not have a home address, the IP source
>        address MUST be 0.0.0.0.

2389,2390c2389,2390
<        as learned from the IP source address of the corresponding
<        Agent Advertisement MUST be used.  This MAY be an address
---
>        as learned from the IP source address of the corresponding Agent
>        Advertisement MUST be used.  In addition, when transmitting

2399,2400d2398
<        which does not appear as an advertised care-of address in
<        the Agent Advertisement.  In addition, when transmitting

2821c2821
<     - the IP Destination Address (as specified in 3.6.1.1)
---
>     - the IP Destination Address (as specified in 3.6.2.3)

3014,3017c3014,3016
<                If the Registration Reply (as received from the Home
<                Agent) contains a Home Address which is not 0.0.0.0,
<                then the IP Destination Address is copied from the Home
<                Address field of the Registration Reply.  Otherwise, the
---
>                Copied from the IP Source Address of the Registration
>                Request.

3026,3027d3024
<                IP Destination Address of the Registration Reply is set
<                to be 255.255.255.255.

3242,3243c3236,3237
<            extension or verify that the authenticator value has been
<            checked by another agent with which it has a security
---
>            extension.  or verify that the authenticator value has
>            been checked by another agent with which it has a security

3445c3438
<    This section provides the specific rules by which home agents pick
---
>    This section provides the specific rules by which mobile nodes pick

3695c3683
<    address associated with the mobile node's IP address.
---
>    address associated to the mobile node's IP address.

3734,3737c3721,3724
<    of the encapsulated datagram MUST be the address sent to the mobile
<    node in the home agent field of the registration reply.  That is, the
<    home agent cannot use the the address of some other network interface
<    as the source address.
---
>    of the encapsulated datagram MUST be the address that the mobile
>    node used in the home agent field of the registration request.  That
>    is, the home agent cannot use the the address of some other network
>    interface as the source address.

3844c3833
<    In order to receive multicasts, a mobile node MUST join the multicast
---
>    In order receive multicasts, a mobile node MUST join the multicast

3895,3900c3883,3888
<    A mobile node can be a router that is responsible for the mobility of
<    one or more entire networks moving together, perhaps on an airplane,
<    a ship, a train, an automobile, a bicycle, or a kayak.  The nodes
<    connected to a network served by the mobile router may themselves
<    be fixed nodes or mobile nodes or routers.  In this document, such
<    networks are called "mobile networks".
---
>    A mobile node can be a router, which is responsible for the mobility
>    of one or more entire networks moving together, perhaps on an
>    airplane, a ship, a train, an automobile, a bicycle, or a kayak.
>    The nodes connected to a network served by the mobile router may
>    themselves be fixed nodes or mobile nodes or routers.  In this
>    document, such networks are called "mobile networks".

4093c4082
<    of its home agent.  The ARP packet from the home agent MUST be
---
>    of its home agent.  Th ARP packet from the home agent MUST be

4187,4193c4173,4187
<        Address is set to the link-layer address of the mobile node.
<        If, instead, the home agent rejects the Registration Request,
<        the home agent MUST NOT make any change to the way it performs
<        ARP processing (gratuitous nor proxy) for the mobile node.  In
<        this latter case, the home agent should operate as if the mobile
<        node has not returned home, and continue to perform proxy ARP on
<        behalf of the mobile node.
---
>        Address is set to the link-layer address of the mobile node.  If,
>        instead, the home agent rejects the Registration Request, the
>        home agent MUST NOT make any change to the way it performs ARP
>        processing (gratuitous nor proxy) for the mobile node.  In this
>        latter case, the HA should operate as if the MN has not returned
>        home, and continue to perform proxy ARP on behalf of the MN.

4628d4627
<     - Ken Imboden (Candlestick Networks, Inc.)
4639d4637
<     - Alper Yegin (NTT DoCoMo)

5050,5060c5050
< G.1. Recent Changes Subsequent to Revision 08 of RFC2002bis
< 
<    The following minor revisions had to be made, necessitating this new
<    revision for RFC2002bis:
< 
<     -  Specification for Destination IP address of Registration
<        Reply transmitted from Foreign Agent, to avoid any possible
<        transmission to IP address 0.0.0.0.

5153,5156c5143,5145
<     -  In section 4.2.3, specification that multihomed home agents MUST
<        use the the address sent to the mobile node in the home agent
<        field of the registration reply as the source address in the
<        outer IP header of the encapsulated datagram.
---
>     -  Specification that multihomed home agents MUST use the registered
>        care-of address as the source address in the outer IP header of
>        the encapsulated datagram.

5174,5176c5163,5165
<        a multicast group at the router on the foreign network, the
<        mobile node MUST use its home address as the source IP address
<        for multicast packets,
---
>        multicast group at the router on the foreign network, the mobile
>        node MUST use its home address as the source IP address for
>        multicast packets,

5430,5433c5430,5433
<     [3] J. Border, M. Kojo, J. Griner, G. Montenegro, and Z. Shelby.
<         Performance Enhancing Proxies Intended to Mitigate Link-Related
<         Degradations.  Request for Comments (Proposed Standard) 3135,
<         Internet Engineering Task Force, June 2001.
---
>     [3] J. Border, M. Kojo, J. Griner, G. Montenegro, and
>         Z. Shelby.  Performance Enhancing Proxies (work in
>         progress).  Internet Draft, Internet Engineering Task Force.
>         draft-ietf-pilc-pep-07.txt, May 2001.

5458,5460c5458,5460
<         End-to-end Performance Implications of Links with Errors.
<         Request for Comments (Proposed Standard) 3155, Internet
<         Engineering Task Force, August 2001.
---
>         Performance Implications of Link-Layer Characteristics:  Links
>         with Errors.  Internet Draft, Internet Engineering Task Force.
>         draft-ietf-pilc-error-08.txt, June 2001.

5478,5479c5478
<         Extensions.  Request for Comments (Proposed Standard) 3115,
<         Internet Engineering Task Force, April 2001.
---
>         Extensions, April 2001.

5591,5593c5591,5593
<    [35] Charles E. Perkins and Pat R. Calhoun.  AAA Registration Keys
<         for Mobile IP (work in progress).
<         draft-ietf-mobileip-aaa-key-05.txt, May 2001.
---
>    [35] C. Perkins and P. Calhoun.  Generalized Key Distribution
>         Extensions for Mobile IP (work in progress).
>         draft-ietf-mobileip-gen-key-01.txt, July 2001.

---

From: Bjorn Andersson <[email-masked]>
Date: Thu, 27 Dec 2001 10:00:48 +0200

Charles,

in rfc2002-bis-08 there is still a typo in section 6.4 where there are
overlapping ranges in the error codes. I sent a note about this
some months ago. The current text is as follows:

         0-8        Success Codes
         9-63       No allocation guidelines currently exist
         64-128     Error Codes from the Foreign Agent
         128-192    Error Codes from the Home Agent
         193-255    No allocation guidelines currently exist

but should be:

         0-8        Success Codes
         9-63       No allocation guidelines currently exist
         64-127     Error Codes from the Foreign Agent
         128-192    Error Codes from the Home Agent
         193-255    No allocation guidelines currently exist

Section 6.3 mentions that the One-byte padding can be used in
registration message. There is no reference to this, and the
draft only motivates the need for the One-byte padding in
advertisements. I think that the extension should be removed
from the list of registration extensions mentioned in 6.3.

Regards,
Bjorn
 
-- 
Bjorn Andersson <[email-masked]>                       +358 50 341 2556
Lifix Systems Oy <http://www.lifix.fi/>                 PGP id 5AFC144B
Yliopistonkatu 5, 3rd floor; FIN-00100 Helsinki